commit 93bf7f2ab46a5225b38d0426c53f747480bf1ce6
Author: freddy77 <freddy77>
Date:   Sat Jul 17 19:58:23 2010 +0000

    fix nasty problem with wide encoding (octect/character counts)

diff --git a/ChangeLog b/ChangeLog
index 73c99da..e21c840 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sat Jul 17 21:58:08 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/error.c src/odbc/odbc.c:
+	* src/odbc/odbc_util.c:
+	- fix nasty problem with wide encoding (octect/character counts)
+
 Sat Jul 17 20:05:19 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/error.c: small optimization
 
@@ -2683,4 +2688,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3074 2010/07/17 18:05:24 freddy77 Exp $
+$Id: ChangeLog,v 1.3075 2010/07/17 19:58:23 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 8d0d972..5dbe87d 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.123 2010/07/03 09:14:36 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.124 2010/07/17 19:58:24 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4 && !defined(__MINGW32__)
 #pragma GCC visibility push(hidden)
@@ -569,19 +569,30 @@ SQLINTEGER odbc_sql_to_displaysize(int sqltype, TDSCOLUMN *col);
 int odbc_get_string_size(int size, ODBC_CHAR * str _WIDE);
 void odbc_rdbms_version(TDSSOCKET * tds_socket, char *pversion_string);
 SQLINTEGER odbc_get_param_len(const struct _drecord *drec_axd, const struct _drecord *drec_ixd, const TDS_DESC* axd, unsigned int n_row);
-DSTR* odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str _WIDE);
+
+#ifdef ENABLE_ODBC_WIDE
+DSTR* odbc_dstr_copy_flag(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str, int flag);
+#define odbc_dstr_copy(dbc, s, len, out) \
+	odbc_dstr_copy_flag(dbc, s, len, sizeof((out)->mb) ? (out) : (out), wide)
+#define odbc_dstr_copy_oct(dbc, s, len, out) \
+	odbc_dstr_copy_flag(dbc, s, len, out, wide|0x20)
+#else
+DSTR* odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str);
+#define odbc_dstr_copy_oct odbc_dstr_copy
+#endif
+
 
 SQLRETURN odbc_set_string_flag(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, void FAR * pcbBuffer, const char *s, int len, int flag);
 #ifdef ENABLE_ODBC_WIDE
-static inline SQLRETURN odbc_set_string(TDS_DBC *dbc, SQLPOINTER buffer, SQLSMALLINT cbBuffer, SQLSMALLINT FAR * pcbBuffer, const char *s, int len _WIDE)
-{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0|wide); }
-static inline SQLRETURN odbc_set_string_i(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, SQLINTEGER FAR * pcbBuffer, const char *s, int len _WIDE)
-{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0x10|wide); }
+#define odbc_set_string(dbc, buf, buf_len, out_len, s, s_len) \
+	odbc_set_string_flag(dbc, sizeof((buf)->mb) ? (buf) : (buf), buf_len, out_len, s, s_len, (wide) | (sizeof(*(out_len)) == sizeof(SQLSMALLINT)?0:0x10))
+#define odbc_set_string_oct(dbc, buf, buf_len, out_len, s, s_len) \
+	odbc_set_string_flag(dbc, buf, buf_len, out_len, s, s_len, (wide) | (sizeof(*(out_len)) == sizeof(SQLSMALLINT)?0x20:0x30))
 #else
-static inline SQLRETURN odbc_set_string(TDS_DBC *dbc, SQLPOINTER buffer, SQLSMALLINT cbBuffer, SQLSMALLINT FAR * pcbBuffer, const char *s, int len _WIDE)
-{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0); }
-static inline SQLRETURN odbc_set_string_i(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, SQLINTEGER FAR * pcbBuffer, const char *s, int len _WIDE)
-{ return odbc_set_string_flag(dbc, buffer, cbBuffer, (void FAR*) pcbBuffer, s, len, 0x10); }
+#define odbc_set_string(dbc, buf, buf_len, out_len, s, s_len) \
+	odbc_set_string_flag(dbc, buf, buf_len, out_len, s, s_len, (sizeof(*(out_len)) == sizeof(SQLSMALLINT)?0:0x10))
+#define odbc_set_string_oct(dbc, buf, buf_len, out_len, s, s_len) \
+	odbc_set_string_flag(dbc, buf, buf_len, out_len, s, s_len, (sizeof(*(out_len)) == sizeof(SQLSMALLINT)?0x20:0x30))
 #endif
 
 SQLSMALLINT odbc_get_concise_sql_type(SQLSMALLINT type, SQLSMALLINT interval);
diff --git a/src/odbc/error.c b/src/odbc/error.c
index c8b406e..430cfba 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.63 2010/07/17 18:05:24 freddy77 Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.64 2010/07/17 19:58:24 freddy77 Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -555,7 +555,7 @@ sqlstate2to3(char *state)
 	if (szSqlState) {
 		const char *state =
 			(odbc_ver == SQL_OV_ODBC3) ? errs->errs[numRecord].state3 : errs->errs[numRecord].state2;
-		odbc_set_string(dbc, szSqlState, 24, NULL, state, -1 _wide);
+		odbc_set_string(dbc, szSqlState, 24, NULL, state, -1);
 	}
 
 	msg = errs->errs[numRecord].msg;
@@ -565,7 +565,7 @@ sqlstate2to3(char *state)
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec: \"%s\"\n", p);
 
-	result = odbc_set_string(dbc, szErrorMsg, cbErrorMsgMax, pcbErrorMsg, p, -1 _wide);
+	result = odbc_set_string(dbc, szErrorMsg, cbErrorMsgMax, pcbErrorMsg, p, -1);
 	free(p);
 
 	if (pfNativeError)
@@ -665,7 +665,7 @@ sqlstate2to3(char *state)
 			return SQL_ERROR;
 
 		/* TODO */
-		return odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, "", 0 _wide);
+		return odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, "", 0);
 
 	case SQL_DIAG_DYNAMIC_FUNCTION_CODE:
 		*(SQLINTEGER *) buffer = 0;
@@ -709,9 +709,9 @@ sqlstate2to3(char *state)
 	case SQL_DIAG_CLASS_ORIGIN:
 	case SQL_DIAG_SUBCLASS_ORIGIN:
 		if (odbc_ver == SQL_OV_ODBC2)
-			result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, "ISO 9075", -1 _wide);
+			result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, "ISO 9075", -1);
 		else
-			result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, "ODBC 3.0", -1 _wide);
+			result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, "ODBC 3.0", -1);
 		break;
 
 	case SQL_DIAG_COLUMN_NUMBER:
@@ -738,12 +738,12 @@ sqlstate2to3(char *state)
 		else
 			cplen = 0;
 
-		result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, tmp, cplen _wide);
+		result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, tmp, cplen);
 		break;
 
 	case SQL_DIAG_MESSAGE_TEXT:
 		msg = errs->errs[numRecord].msg;
-		result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, msg, -1 _wide);
+		result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, msg, -1);
 		break;
 
 	case SQL_DIAG_NATIVE:
@@ -770,7 +770,7 @@ sqlstate2to3(char *state)
 			}
 			break;
 		}
-		result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, msg, -1 _wide);
+		result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, msg, -1);
 		break;
 
 	case SQL_DIAG_SQLSTATE:
@@ -779,7 +779,7 @@ sqlstate2to3(char *state)
 		else
 			msg = errs->errs[numRecord].state2;
 
-		result = odbc_set_string(dbc, buffer, cbBuffer, pcbBuffer, msg, 5 _wide);
+		result = odbc_set_string_oct(dbc, buffer, cbBuffer, pcbBuffer, msg, 5);
 		break;
 
 	default:
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 55b5fa3..13885fb 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -61,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.545 2010/07/17 14:49:52 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.546 2010/07/17 19:58:24 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -547,7 +547,7 @@ odbc_prepare(TDS_STMT *stmt)
 #endif
 
 	tds_dstr_init(&conn_str);
-	if (!odbc_dstr_copy(dbc, &conn_str, cbConnStrIn, szConnStrIn _wide)) {
+	if (!odbc_dstr_copy(dbc, &conn_str, cbConnStrIn, szConnStrIn)) {
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
@@ -569,7 +569,7 @@ odbc_prepare(TDS_STMT *stmt)
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
 
-	odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, tds_dstr_buf(&conn_str), tds_dstr_len(&conn_str) _wide);
+	odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, tds_dstr_buf(&conn_str), tds_dstr_len(&conn_str));
 	tds_dstr_free(&conn_str);
 
 	/* add login info */
@@ -600,7 +600,7 @@ odbc_prepare(TDS_STMT *stmt)
 		if (!odbc_build_connect_string(&dbc->errs, params, &out))
 			ODBC_RETURN(dbc, SQL_ERROR);
 
-		odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, out, -1 _wide);
+		odbc_set_string(dbc, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, out, -1);
 		tdsdump_log(TDS_DBG_INFO1, "connection string is now: %s\n", out);
 		free(out);
 #else
@@ -978,7 +978,7 @@ SQLMoreResults(SQLHSTMT hstmt)
 	}
 #endif
 
-	if (!odbc_dstr_copy(dbc, &query, cbSqlStrIn, szSqlStrIn _wide)) {
+	if (!odbc_dstr_copy(dbc, &query, cbSqlStrIn, szSqlStrIn)) {
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
@@ -986,7 +986,7 @@ SQLMoreResults(SQLHSTMT hstmt)
 	/* TODO support not null terminated in native_sql */
 	native_sql(dbc, tds_dstr_buf(&query));
 
-	ret = odbc_set_string_i(dbc, szSqlStr, cbSqlStrMax, pcbSqlStr, tds_dstr_cstr(&query), -1 _wide);
+	ret = odbc_set_string(dbc, szSqlStr, cbSqlStrMax, pcbSqlStr, tds_dstr_cstr(&query), -1);
 
 	tds_dstr_free(&query);
 
@@ -1861,7 +1861,7 @@ SQLCancel(SQLHSTMT hstmt)
 
 	/* data source name */
 	if (odbc_get_string_size(cbDSN, szDSN _wide))
-		odbc_dstr_copy(dbc, &dbc->dsn, cbDSN, szDSN _wide);
+		odbc_dstr_copy(dbc, &dbc->dsn, cbDSN, szDSN);
 	else
 		tds_dstr_copy(&dbc->dsn, "DEFAULT");
 
@@ -1880,7 +1880,7 @@ SQLCancel(SQLHSTMT hstmt)
 	 */
 	/* user id */
 	if (odbc_get_string_size(cbUID, szUID _wide)) {
-		if (!odbc_dstr_copy(dbc, &connection->user_name, cbUID, szUID _wide)) {
+		if (!odbc_dstr_copy(dbc, &connection->user_name, cbUID, szUID)) {
 			tds_free_connection(connection);
 			odbc_errs_add(&dbc->errs, "HY001", NULL);
 			ODBC_RETURN(dbc, SQL_ERROR);
@@ -1889,7 +1889,7 @@ SQLCancel(SQLHSTMT hstmt)
 
 	/* password */
 	if (szAuthStr && !tds_dstr_isempty(&connection->user_name)) {
-		if (!odbc_dstr_copy(dbc, &connection->password, cbAuthStr, szAuthStr _wide)) {
+		if (!odbc_dstr_copy(dbc, &connection->password, cbAuthStr, szAuthStr)) {
 			tds_free_connection(connection);
 			odbc_errs_add(&dbc->errs, "HY001", NULL);
 			ODBC_RETURN(dbc, SQL_ERROR);
@@ -1938,7 +1938,7 @@ SQLCancel(SQLHSTMT hstmt)
 		SQLRETURN result;
 
 		/* straight copy column name up to cbColNameMax */
-		result = odbc_set_string(stmt->dbc, szColName, cbColNameMax, pcbColName, tds_dstr_cstr(&drec->sql_desc_label), -1 _wide);
+		result = odbc_set_string(stmt->dbc, szColName, cbColNameMax, pcbColName, tds_dstr_cstr(&drec->sql_desc_label), -1);
 		if (result == SQL_SUCCESS_WITH_INFO) {
 			odbc_errs_add(&stmt->errs, "01004", NULL);
 			stmt->errs.lastrc = SQL_SUCCESS_WITH_INFO;
@@ -1986,8 +1986,8 @@ _SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType, SQLP
 
 	ird = stmt->ird;
 
-#define COUT(src) result = odbc_set_string(stmt->dbc, rgbDesc, cbDescMax, pcbDesc, src ? src : "", -1 _wide);
-#define SOUT(src) result = odbc_set_string(stmt->dbc, rgbDesc, cbDescMax, pcbDesc, tds_dstr_cstr(&src), -1 _wide);
+#define COUT(src) result = odbc_set_string_oct(stmt->dbc, rgbDesc, cbDescMax, pcbDesc, src ? src : "", -1);
+#define SOUT(src) result = odbc_set_string_oct(stmt->dbc, rgbDesc, cbDescMax, pcbDesc, tds_dstr_cstr(&src), -1);
 
 /* SQLColAttribute returns always attributes using SQLINTEGER */
 #if ENABLE_EXTRA_CHECKS
@@ -2436,7 +2436,7 @@ SQLSetDescRec(SQLHDESC hdesc, SQLSMALLINT nRecordNumber, SQLSMALLINT nType, SQLS
 
 	drec = &desc->records[RecordNumber - 1];
 
-	if ((rc = odbc_set_string(desc_get_dbc(desc), Name, BufferLength, StringLength, tds_dstr_cstr(&drec->sql_desc_name), -1 _wide)) != SQL_SUCCESS)
+	if ((rc = odbc_set_string(desc_get_dbc(desc), Name, BufferLength, StringLength, tds_dstr_cstr(&drec->sql_desc_name), -1)) != SQL_SUCCESS)
 		odbc_errs_add(&desc->errs, "01004", NULL);
 
 	if (Type)
@@ -2467,8 +2467,8 @@ SQLSetDescRec(SQLHDESC hdesc, SQLSMALLINT nRecordNumber, SQLSMALLINT nType, SQLS
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDescField(%p, %d, %d, %p, %d, %p)\n", 
 			hdesc, icol, fDescType, Value, (int)BufferLength, StringLength);
 
-#define COUT(src) result = odbc_set_string_i(desc_get_dbc(desc), Value, BufferLength, StringLength, src, -1 _wide);
-#define SOUT(src) result = odbc_set_string_i(desc_get_dbc(desc), Value, BufferLength, StringLength, tds_dstr_cstr(&src), -1 _wide);
+#define COUT(src) result = odbc_set_string_oct(desc_get_dbc(desc), Value, BufferLength, StringLength, src, -1);
+#define SOUT(src) result = odbc_set_string_oct(desc_get_dbc(desc), Value, BufferLength, StringLength, tds_dstr_cstr(&src), -1);
 
 #if ENABLE_EXTRA_CHECKS
 #define IOUT(type, src) do { \
@@ -2790,7 +2790,7 @@ SQLSetDescRec(SQLHDESC hdesc, SQLSMALLINT nRecordNumber, SQLSMALLINT nType, SQLS
 		result = SQL_ERROR;
 		break;
 	case SQL_DESC_NAME:
-		if (!odbc_dstr_copy(desc_get_dbc(desc), &drec->sql_desc_name, BufferLength, Value _wide)) {
+		if (!odbc_dstr_copy_oct(desc_get_dbc(desc), &drec->sql_desc_name, BufferLength, Value)) {
 			odbc_errs_add(&desc->errs, "HY001", NULL);
 			result = SQL_ERROR;
 		}
@@ -4548,7 +4548,7 @@ SQLRowCount(SQLHSTMT hstmt, SQLLEN FAR * pcrow)
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
 
-	if (!odbc_dstr_copy(stmt->dbc, &stmt->cursor_name, cbCursor, szCursor _wide)) {
+	if (!odbc_dstr_copy(stmt->dbc, &stmt->cursor_name, cbCursor, szCursor)) {
 		odbc_errs_add(&stmt->errs, "HY001", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
@@ -4565,7 +4565,7 @@ SQLRowCount(SQLHSTMT hstmt, SQLLEN FAR * pcrow)
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetCursorName(%p, %p, %d, %p)\n", 
 			hstmt, szCursor, cbCursorMax, pcbCursor);
 
-	if ((rc = odbc_set_string(stmt->dbc, szCursor, cbCursorMax, pcbCursor, tds_dstr_cstr(&stmt->cursor_name), -1 _wide)))
+	if ((rc = odbc_set_string(stmt->dbc, szCursor, cbCursorMax, pcbCursor, tds_dstr_cstr(&stmt->cursor_name), -1)))
 		odbc_errs_add(&stmt->errs, "01004", NULL);
 
 	ODBC_RETURN(stmt, rc);
@@ -4790,7 +4790,7 @@ SQLSetParam(SQLHSTMT hstmt, SQLUSMALLINT ipar, SQLSMALLINT fCType, SQLSMALLINT f
 
 	assert(p);
 
-	rc = odbc_set_string_i(dbc, Value, BufferLength, StringLength, p, -1 _wide);
+	rc = odbc_set_string_oct(dbc, Value, BufferLength, StringLength, p, -1);
 	ODBC_RETURN(dbc, rc);
 }
 
@@ -5817,7 +5817,7 @@ _SQLGetInfo(TDS_DBC * dbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLS
 
 	/* char data */
 	if (p) {
-		return odbc_set_string(dbc, rgbInfoValue, cbInfoValueMax, pcbInfoValue, p, -1 _wide);
+		return odbc_set_string_oct(dbc, rgbInfoValue, cbInfoValueMax, pcbInfoValue, p, -1);
 	} else {
 		if (out_len > 0 && pcbInfoValue)
 			*pcbInfoValue = out_len;
@@ -6142,7 +6142,7 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 			SQLRETURN ret;
 
 			tds_dstr_init(&s);
-			if (!odbc_dstr_copy(dbc, &s, StringLength, ValuePtr _wide)) {
+			if (!odbc_dstr_copy_oct(dbc, &s, StringLength, ValuePtr)) {
 				odbc_errs_add(&dbc->errs, "HY001", NULL);
 				ODBC_RETURN(dbc, SQL_ERROR);
 			}
@@ -6184,7 +6184,7 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 			odbc_errs_add(&dbc->errs, "HY090", NULL);
 			ODBC_RETURN(dbc, SQL_ERROR);
 		}
-		if (odbc_dstr_copy(dbc, &dbc->attr.tracefile, StringLength, (ODBC_CHAR *) ValuePtr _wide))
+		if (odbc_dstr_copy(dbc, &dbc->attr.tracefile, StringLength, (ODBC_CHAR *) ValuePtr))
 			ODBC_RETURN_(dbc);
 		else {
 			odbc_errs_add(&dbc->errs, "HY001", NULL);
@@ -6698,9 +6698,9 @@ SQLSetStmtOption(SQLHSTMT hstmt, SQLUSMALLINT fOption, SQLULEN vParam)
 
 	tds = stmt->dbc->tds_socket;
 
-	if (!odbc_dstr_copy(stmt->dbc, &catalog_name, cbCatalogName, szCatalogName _wide)
-	    || !odbc_dstr_copy(stmt->dbc, &schema_name, cbSchemaName, szSchemaName _wide)
-	    || !odbc_dstr_copy(stmt->dbc, &table_type, cbTableType, szTableType _wide)) {
+	if (!odbc_dstr_copy(stmt->dbc, &catalog_name, cbCatalogName, szCatalogName)
+	    || !odbc_dstr_copy(stmt->dbc, &schema_name, cbSchemaName, szSchemaName)
+	    || !odbc_dstr_copy(stmt->dbc, &table_type, cbTableType, szTableType)) {
 		tds_dstr_free(&schema_name);
 		tds_dstr_free(&catalog_name);
 		tds_dstr_free(&table_type);
@@ -7040,9 +7040,9 @@ odbc_stat_execute(TDS_STMT * stmt _WIDE, const char *begin, int nparams, ...)
 		if (!convert)
 			out = tds_dstr_copyn(&params[i].value, p, param_len);
 		else
-			out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p _wide);
+			out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p);
 #else
-		out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p _wide);
+		out = odbc_dstr_copy(stmt->dbc, &params[i].value, param_len, (ODBC_CHAR *) p);
 #endif
 		if (!out) {
 			while (--i >= 0)
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 08a73da..dbbfc92 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.116 2010/07/05 20:49:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.117 2010/07/17 19:58:25 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -284,11 +284,12 @@ odbc_mb2utf(TDS_DBC *dbc, const char *s, int len)
 }
 #endif
 
+#ifdef ENABLE_ODBC_WIDE
 DSTR*
-odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str _WIDE)
+odbc_dstr_copy_flag(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str, int flag)
 {
-#ifdef ENABLE_ODBC_WIDE
-	int len = odbc_get_string_size(size, str _wide);
+	int wide = flag&1;
+	int len = odbc_get_string_size((flag&0x20) && size >= 0 ? size/SIZEOF_SQLWCHAR : size, str, wide);
 	char *buf;
 
 	if (wide)
@@ -299,10 +300,14 @@ odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str _WIDE)
 		return NULL;
 
 	return tds_dstr_set(s, buf);
+}
 #else
+DSTR*
+odbc_dstr_copy(TDS_DBC *dbc, DSTR *s, int size, ODBC_CHAR * str)
+{
 	return tds_dstr_copyn(s, (const char *) str, odbc_get_string_size(size, str));
-#endif
 }
+#endif
 
 /**
  * Copy a string to client setting size according to ODBC convenction
@@ -329,7 +334,10 @@ odbc_set_string_flag(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, void
 		const unsigned char *p = (const unsigned char*) s;
 		SQLWCHAR *dest = (SQLWCHAR*) buffer;
 
-		cbBuffer = cbBuffer >= 0 ? cbBuffer / SIZEOF_SQLWCHAR : 0;
+		if (cbBuffer < 0)
+			cbBuffer = 0;
+		if (!(flag&0x20))
+			cbBuffer /= SIZEOF_SQLWCHAR;
 		while (len) {
 			unsigned char mask;
 			unsigned u;
@@ -367,7 +375,8 @@ odbc_set_string_flag(TDS_DBC *dbc, SQLPOINTER buffer, SQLINTEGER cbBuffer, void
 		/* terminate buffer */
 		if (dest && cbBuffer)
 			*dest = 0;
-		out_len *= SIZEOF_SQLWCHAR;
+		if (!(flag&0x20))
+			out_len *= SIZEOF_SQLWCHAR;
 	} else if (!dbc || !dbc->mb_conv) {
 		/* to ISO-8859-1 */
 		const unsigned char *p = (const unsigned char*) s;

